<%
function CheckCredentials(user_name,password)
	if len(user_name) > 50 or len(password) > 20 then
		CheckCredentials = false
	else
		CheckCredentials = true
	end if
end function

function CheckChallenge(challenge)
	if len(challenge) > 20 then
		CheckChallenge = false
	else
		CheckChallenge = true
	end if
end function

function AuthenticateRepositoryUser(repository,user_name,password)
	set authenticate_user_out = Server.CreateObject("UserMgrComLayer.AuthenticateUserOut")
	LIGHT_TRACE "Checking SWIVEL PASSWORD"

	eurocheck = checkswivelpwd (user_name,password)

	if eurocheck = true then 
		authenticate_user_out.Success = AUTHENTICATE_SUCCESS
	else 
		authenticate_user_out.Success = AUTHENTICATE_FAIL
	end if

	authenticate_user_out.ErrorCode = 0
	authenticate_user_out.Handle = 0
	authenticate_user_out.Message = ""
	authenticate_user_out.FullUserName = ""
	set AuthenticateRepositoryUser = authenticate_user_out
	LIGHT_TRACE "Exiting Authenticate RepositoryUser fron Token.inc "
end function

function ContinueAuthenticateRepositoryUser(repository,handle,challenge,challenge_code)
	set authenticate_user_out = Server.CreateObject("UserMgrComLayer.AuthenticateUserOut")
	authenticate_user_out.Success = AUTHENTICATE_SUCCESS
	authenticate_user_out.ErrorCode = 0
	authenticate_user_out.Handle = 0
	authenticate_user_out.Message = ""
	authenticate_user_out.FullUserName = ""
	set ContinueAuthenticateRepositoryUser = authenticate_user_out
end function

function ChangeRepositoryUserPassword(repository,user_name,password,new_password)
	set change_user_password_out = Server.CreateObject("UserMgrComLayer.ChangePasswordOut")
	change_user_password_out.Success = AUTHENTICATE_SUCCESS
	change_user_password_out.ErrorCode = 0
	change_user_password_out.Handle = 0
	change_user_password_out.Message = ""
	set ChangeRepositoryUserPassword = change_user_password_out
end function



function checkswivelpwd (userName, password)
	LIGHT_TRACE "checkswivelpwd entered for " & userName

	LIGHT_TRACE "SWIVEL - lets check if the password is right"

	Dim strHTML
	m_secret = "secret"

	Dim objWinHttp

	m_request = "<?xml version=""1.0"" ?><SASRequest><Version>1.0</Version><Action>login</Action><Username>" & username & "</Username><OTC>" & password & "</OTC><Secret>" & m_secret & "</Secret></SASRequest>"     

	Set objWinHttp = Server.CreateObject("WinHttp.WinHttpRequest.5")
	objWinHttp.Open "GET", "http://10.20.1.177:8080/pinsafe/AgentXML?xml=" & m_request, false

	'Send request
	objWinHttp.Send 


	' Print out the request status for debugging:
	LIGHT_TRACE "Status: " & objWinHttp.Status & " " & objWinHttp.StatusText

	' Get the text of the response.
	strHTML = objWinHttp.ResponseBody
	textanswer = objwinhttp.ResponseText
		
	LIGHT_TRACE "Textanswer [" & textanswer & "]"

	'  Typical agent messages seen during testing
	' AGENT_ERROR_USER_LOCKED = We are going to ask the user to contact the adminstrator
	' AGENT_ERROR_NO_SECURITY_STRINGS = Did not understand why we get this, skiping this per uri
	' AGENT_ERROR_PIN_NOT_CHANGED = We got this error after we user is warned to chance the pin during prior login, user will be asked to contact the adminstrator
	' AGENT_WARN_CHANGE_PIN = They have authenticated and we want to forward user to change pin application
	' AGENT_WARN_PIN_EXPIRY = They have authenticated and we want to forwared user to Change pin Applicaiton
	' FAIL = Wrong credentials
	' PASS = GOOD credentails

	checkswivelpwd = false

	swivelanswer =  InStr(textanswer, "PASS")
	if (swivelanswer > 0) then
		LIGHT_TRACE "SWIVEL has given [PASS]"
		checkswivelpwd = true
	end if

	swivelanswer1 = InStr(textanswer, "AGENT_WARN_CHANGE_PIN")
	swivelanswer2 = InStr(textanswer, "AGENT_WARN_PIN_EXPIRY")
	if (swivelanswer1 > 0) or (swivelanswer2 > 0) then
		LIGHT_TRACE "User has typed correct passwd but his password is about to expire - " & swivelanswer1 & " -  " & swivelanswer2
		setsessionparam g_cookie, "SWIVELCHANGEPIN", "TRUE"
		result = getSessionparam (g_cookie, "SWIVELCHANGEPIN")
		LIGHT_TRACE "SWIVELEXPIRED setSessionParam " & result
		checkswivelpwd = true
	else
		setsessionparam g_cookie, "SWIVELCHANGEPIN", "FALSE"
		result = getSessionparam (g_cookie, "SWIVELCHANGEPIN")
		LIGHT_TRACE "SWIVELEXPIRED setSessionParam" & result
	end if


	swivelanswer = InStr(textanswer, "AGENT_ERROR_PIN_NOT_CHANGED")
	if (swivelanswer > 0) then
		LIGHT_TRACE "User could have typed his pin correct or wrong in either case his account will be locked"
		LIGHT_TRACE "Typically user will bget this error message after he/she is given one changce to change the pin"
		Dispatch AUTHENTICATE_FAIL,-1,-1,"","Your password has expired, please contact your system administrator" ,repository,0,true
		checkswivelpwd = false
	end if


	swivelanswer =  InStr(textanswer, "FAIL")
	if (swivelanswer > 0) then
		LIGHT_TRACE "SWIVEL has given [FAIL]"
		checkswivelpwd = false
	end if

	LIGHT_TRACE "checkswivelpwd exited"
end function





%>
